package de.arminwolf.financeanalyzer.conf;

import java.io.Serializable;
import java.util.Objects;

public class BankAccount implements Serializable, Comparable<BankAccount> {

	private String iban;
	private String bankAccountName;


	public BankAccount() {
	}


	public BankAccount(final String iban, final String bankAccountName) {
		this.iban = iban;
		this.bankAccountName = bankAccountName;
	}


	@Override
	public int compareTo(final BankAccount o) {
		return bankAccountName.compareTo(o.bankAccountName);
	}


	public String getIban() {
		return iban;
	}


	public void setIban(final String iban) {
		this.iban = iban;
	}


	public String getBankAccountName() {
		return bankAccountName;
	}


	public void setBankAccountName(final String bankAccountName) {
		this.bankAccountName = bankAccountName;
	}


	@Override
	public boolean equals(final Object o) {
		if (this == o) return true;
		if (o == null || getClass() != o.getClass()) return false;
		final BankAccount that = (BankAccount) o;
		return Objects.equals(iban, that.iban) && Objects.equals(bankAccountName, that.bankAccountName);
	}


	@Override
	public int hashCode() {
		return Objects.hash(iban, bankAccountName);
	}
}
