package de.arminwolf.financeanalyzer.dao.charts.factories;

import de.arminwolf.financeanalyzer.dao.charts.model.Chart;
import de.arminwolf.financeanalyzer.dao.charts.model.HighChartDAO;
import de.arminwolf.financeanalyzer.dao.charts.model.Series;
import de.arminwolf.financeanalyzer.dao.charts.model.Title;
import de.arminwolf.financeanalyzer.dao.charts.model.XAxis;
import de.arminwolf.financeanalyzer.dao.charts.model.YAxis;
import de.arminwolf.financeanalyzer.util.RandomColorUtil;

import java.util.List;

public class LineChartFactory {


	public static HighChartDAO createLineChart(final String pTitle, final String pChartTitle, final List<String> categories, final List<Series> pData) {
		HighChartDAO lineChart = new HighChartDAO();
		Title        title     = new Title();
		title.setText(pTitle);
		lineChart.setTitle(title);

		XAxis xAxis = new XAxis();
		xAxis.setCategories(categories);

		YAxis yAxis      = new YAxis();
		Title chartTitle = new Title();
		chartTitle.setText(pChartTitle);
		yAxis.setTitle(chartTitle);

		lineChart.setXAxis(xAxis);
		lineChart.setYAxis(yAxis);


		Chart chart = new Chart();
		chart.setType("line");

		lineChart.setChart(chart);
		lineChart.setColors(List.of(RandomColorUtil.getRandomColor()));
		lineChart.setSeries(pData);
		return lineChart;
	}
}
