package de.arminwolf.financeanalyzer.dao.charts.model;

import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonProperty;

import java.io.Serializable;
import java.util.List;

@JsonInclude(JsonInclude.Include.NON_NULL)
public class HighChartDAO implements Serializable {

	private PlotOptions            plotOptions;
	private ToolTip                tooltip;
	private YAxis                  yAxis;
	private XAxis                  xAxis;
	private List<? extends Series> series;
	private Title                  title;
	private Chart                  chart;
	private List<String>           colors;


	@JsonProperty("tooltip")
	public ToolTip getTooltip() {
		return tooltip;
	}


	public void setTooltip(final ToolTip tooltip) {
		this.tooltip = tooltip;
	}


	public YAxis getyAxis() {
		return yAxis;
	}


	public void setyAxis(final YAxis yAxis) {
		this.yAxis = yAxis;
	}


	public XAxis getxAxis() {
		return xAxis;
	}


	public void setxAxis(final XAxis xAxis) {
		this.xAxis = xAxis;
	}


	public List<String> getColors() {
		return colors;
	}


	public void setColors(final List<String> colors) {
		this.colors = colors;
	}


	public PlotOptions getPlotOptions() {
		return this.plotOptions;
	}


	public void setPlotOptions(PlotOptions plotOptions) {
		this.plotOptions = plotOptions;
	}


	@JsonProperty("yAxis")
	public YAxis getYAxis() {
		return this.yAxis;
	}


	public void setYAxis(YAxis yAxis) {
		this.yAxis = yAxis;
	}


	@JsonProperty("xAxis")
	public XAxis getXAxis() {
		return this.xAxis;
	}


	public void setXAxis(XAxis xAxis) {
		this.xAxis = xAxis;
	}


	public List<? extends Series> getSeries() {
		return this.series;
	}


	public void setSeries(List<? extends Series> series) {
		this.series = series;
	}


	public Title getTitle() {
		return this.title;
	}


	public void setTitle(Title title) {
		this.title = title;
	}


	public Chart getChart() {
		return this.chart;
	}


	public void setChart(Chart chart) {
		this.chart = chart;
	}

}

