package de.arminwolf.financeanalyzer.dao.charts.model;

public class Packedbubble {

	private String          minSize;
	private String          maxSize;
	private int             zMin;
	private int             zMax;
	private LayoutAlgorithm layoutAlgorithm;
	private DataLabels      dataLabels;


	public Packedbubble(String minSize, String maxSize, int zMin, int zMax, LayoutAlgorithm layoutAlgorithm, DataLabels dataLabels) {
		this.minSize = minSize;
		this.maxSize = maxSize;
		this.zMin = zMin;
		this.zMax = zMax;
		this.layoutAlgorithm = layoutAlgorithm;
		this.dataLabels = dataLabels;
	}


	public Packedbubble() {
		this.minSize = "20%";
		this.maxSize = "100%";
		this.zMin = 0;
		this.zMax = 1000;
		this.layoutAlgorithm = new LayoutAlgorithm(0.02, true, false, true, true);
		this.dataLabels = new DataLabels(
				true, "{point.name}",
				new Filter("y", ">", 0),
				new Style("black", "none", "normal")
		);
	}


	public String getMinSize() {
		return minSize;
	}


	public void setMinSize(final String minSize) {
		this.minSize = minSize;
	}


	public String getMaxSize() {
		return maxSize;
	}


	public void setMaxSize(final String maxSize) {
		this.maxSize = maxSize;
	}


	public int getzMin() {
		return zMin;
	}


	public void setzMin(final int zMin) {
		this.zMin = zMin;
	}


	public int getzMax() {
		return zMax;
	}


	public void setzMax(final int zMax) {
		this.zMax = zMax;
	}


	public LayoutAlgorithm getLayoutAlgorithm() {
		return layoutAlgorithm;
	}


	public void setLayoutAlgorithm(final LayoutAlgorithm layoutAlgorithm) {
		this.layoutAlgorithm = layoutAlgorithm;
	}


	public DataLabels getDataLabels() {
		return dataLabels;
	}


	public void setDataLabels(final DataLabels dataLabels) {
		this.dataLabels = dataLabels;
	}
}
