package de.arminwolf.financeanalyzer.dao.charts.model;

import com.fasterxml.jackson.annotation.JsonProperty;

import java.io.Serializable;
import java.util.Collection;
import java.util.HashSet;
import java.util.List;
import java.util.Objects;
import java.util.Set;

public class Series implements Serializable {

	private Set<? extends SeriesElement> complexData;
	private List<Float>       data;

	private int stack = 0;

	private String name;



	public void setComplexData(Collection<? extends SeriesElement> data) {
		this.complexData = new HashSet<>(data);
	}


	public String getName() {
		return this.name;
	}


	public int getStack() {
		return stack;
	}


	public void setName(String name) {
		this.name = name;
	}


	public void setData(final List<Float> data) {
		this.data = data;
	}


	@JsonProperty("data")
	public List<?> getData() {

		if (Objects.isNull(data)) {
			return this.complexData.stream().toList();
		} else {
			return this.data;
		}
	}


	public void setStack(final int i) {
		this.stack = i;
	}
}