package de.arminwolf.financeanalyzer.service.usecases;

import de.arminwolf.financeanalyzer.dao.ReportDAO;
import de.arminwolf.financeanalyzer.dao.TransactionDAO;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.stream.Collectors;

import static de.arminwolf.financeanalyzer.util.Constants.EINNAHMEN;

@Service
public class IncomeService {

	public void setIncome(final ReportDAO reportDAO, final List<TransactionDAO> filteredTransactions) {
		reportDAO.setIncomeList(filteredTransactions.stream()
				.filter(e -> e.getAnalyseBetrag().equals(EINNAHMEN))
				.collect(Collectors.toList()));
	}

}
