package de.arminwolf.financeanalyzer.util;

import de.arminwolf.financeanalyzer.dao.model.OutputData;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Comparator;

public class OrderDateStringComparator implements Comparator<OutputData> {

	@Override
	public int compare(final OutputData o1, final OutputData o2) {
		SimpleDateFormat formatter = new SimpleDateFormat("dd-MMM-yyyy");
		try {
			return -1 * formatter.parse(o1.getDate()).compareTo(formatter.parse(o2.getDate()));
		} catch (ParseException e) {
			return -1;
		}
	}
}
