package de.arminwolf.financeanalyzer.util;

import de.arminwolf.financeanalyzer.dao.TransactionDAO;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Comparator;

public class TransactionDateStringComparator implements Comparator<TransactionDAO> {

	@Override
	public int compare(final TransactionDAO o1, final TransactionDAO o2) {
		SimpleDateFormat formatter = new SimpleDateFormat("dd-MMM-yyyy");
		try {
			return formatter.parse(o1.getBuchungstag()).compareTo(formatter.parse(o2.getBuchungstag()));
		} catch (ParseException e) {
			return -1;
		}
	}


}
